xref: /haiku/configure (revision e22ea41c57cc7f8377e09ff321bb421ffd4a0509)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15825700d3SAugustin Cavalier  --help                      Prints out this help.
16825700d3SAugustin Cavalier  --update                    Re-runs last configure invocation [must be given
17825700d3SAugustin Cavalier                              as first option!]
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
2814d8c772SAlexander von Gluck IV  --build-cross-tools <arch>
2914d8c772SAlexander von Gluck IV                              Assume cross compilation.
3014d8c772SAlexander von Gluck IV                              Toolchain will be compiled and placed in the
3114d8c772SAlexander von Gluck IV                              output directory under "cross-tools". The
3214d8c772SAlexander von Gluck IV                              HAIKU_* tools variables will be set accordingly.
3320ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
345bd0fbd1SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k",
35c59cde3dSAlexander von Gluck IV                              "arm", "arm64", "riscv64", "sparc"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
41eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
42eccc7665SIngo Weinhold                              path to the directory where the cross
43eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
440da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
45eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
4614d8c772SAlexander von Gluck IV  --cross-tools-source <buildtools dir>
4714d8c772SAlexander von Gluck IV                              Toolchain sources for cross compilation.
4814d8c772SAlexander von Gluck IV                              <buildtools dir> defines the location of the
4914d8c772SAlexander von Gluck IV                              buildtools sources.
50a66c32ddSIngo Weinhold  --distro-compatibility <level>
51a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
52a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
53a66c32ddSIngo Weinhold                              files will contain the respective trademarks
54a66c32ddSIngo Weinhold                              accordingly.
55a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
56a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
57a66c32ddSIngo Weinhold                              default -- any other distro (default value).
582ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
592ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
602ebcd86dSIngo Weinhold                              this.
6176fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6276fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6376fa0be3SIngo Weinhold                              patched sources. This is preferable when
6476fa0be3SIngo Weinhold                              distributing on physical mediums.
651974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
664880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
674880ae01SJessica Hamilton                              on to the make building the build tools.
68aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
69aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
70e9e00b80SJessica Hamilton  --sysroot                   The location of the cross-compiler sysroot,
71e9e00b80SJessica Hamilton                              primarily for CI environments or cross-compilers
72e9e00b80SJessica Hamilton                              used outside of the Haiku build system.
73483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
74483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
75483b28e4SIngo Weinhold                              host system. The installed build tools for that
76483b28e4SIngo Weinhold                              architecture will be used.
77483b28e4SIngo Weinhold                              This option can be specified multiple times. The
78483b28e4SIngo Weinhold                              first occurrence specifies the primary
79483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
80483b28e4SIngo Weinhold                              ones the secondary architectures.
81d73993ffSAugustin Cavalier  --use-clang <arch>          Build with host Clang instead of GCC cross
82d73993ffSAugustin Cavalier                              compiler, targeting <arch>
83eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
845a34a443SFrançois Revol                              process, but uses more memory.
85ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
86a5c952dbSAugustin Cavalier                              optimizations. (Only for GCC 4+.)
870385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
88fc2c93fbSAugustin Cavalier  --no-full-xattr             Do not use Linux/*BSD/Darwin's native extended file
89fc2c93fbSAugustin Cavalier                              attributes as Haiku attributes. If they are still
90fc2c93fbSAugustin Cavalier                              available, they will be used to store hashes for
91fc2c93fbSAugustin Cavalier                              the attribute emulation layer.
92fc2c93fbSAugustin Cavalier  --no-xattr                  Do not use Linux/*BSD/Darwin's native extended file
93fc2c93fbSAugustin Cavalier                              attributes for Haiku extended attributes at all,
94fc2c93fbSAugustin Cavalier                              even if they are available.
954da6cf84SFrançois Revol  --with-gdb <gdb sources dir>
964da6cf84SFrançois Revol                              specify the path to a GDB source dir, to build
974da6cf84SFrançois Revol                              GDB for each arch we build the cross-tools for.
9804be20a7SJérôme Duval  --use-stack-protector       Build with stack protection enabled
9931f27c4dSAlexander von Gluck IV  --efi-signing-key           Private keyfile to sign any EFI bootloaders
100338b8dc3SIngo Weinhold
101338b8dc3SIngo Weinholdenvironment variables:
10263701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
10365706842SAugustin Cavalier  HAIKU_AR_<arch>             The static library archiver for <arch>.
104c0e8cc1aSIngo Weinhold                              Defaults to "ar".
10565706842SAugustin Cavalier  HAIKU_CC_<arch>             The compiler for <arch>. Defaults to "gcc".
10665706842SAugustin Cavalier  HAIKU_LD_<arch>             The <arch> linker. Defaults to "ld".
10765706842SAugustin Cavalier  HAIKU_OBJCOPY_<arch>        The <arch> objcopy to be used. Defaults to
108c0e8cc1aSIngo Weinhold                              "objcopy".
10965706842SAugustin Cavalier  HAIKU_RANLIB_<arch>         The static library indexer for <arch>. Defaults
110c0e8cc1aSIngo Weinhold                              to "ranlib".
11165706842SAugustin Cavalier  HAIKU_STRIP_<arch>          The <arch> strip command. Defaults to "strip".
112a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
113c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
114c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
115c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
116c0e8cc1aSIngo Weinhold                              Defaults to "".
117c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
118c0e8cc1aSIngo Weinhold                              Defaults to "".
119252e4f62SAugustin Cavalier  HAIKU_LINKFLAGS_<arch>      The flags passed to the compiler when linking for
120252e4f62SAugustin Cavalier                              target architecture <arch>. Defaults to "".
121c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
122c0e8cc1aSIngo Weinhold                              Defaults to "".
123c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
124c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
125241b61a7SAugustin Cavalier                              "cru".
126c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
127c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
128c0e8cc1aSIngo Weinhold                              "x".
12964f6da31SIngo Weinhold
130c0e8cc1aSIngo WeinholdNon-default output directories:
13164f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13264f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
13364f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
13464f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
13564f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
13664f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
13764f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
13864f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
13964f6da31SIngo Weinhold  non-default location and running jam.
14064f6da31SIngo Weinhold
14164f6da31SIngo Weinhold
142022fa244SIngo WeinholdEOF
143022fa244SIngo Weinhold}
144022fa244SIngo Weinhold
145022fa244SIngo Weinhold# assertparam
146022fa244SIngo Weinhold#
147022fa244SIngo Weinhold# Checks whether at least one parameter is left.
148022fa244SIngo Weinhold#
149022fa244SIngo Weinholdassertparam()
150022fa244SIngo Weinhold{
15120ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
152022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
153022fa244SIngo Weinhold		exit 1
154022fa244SIngo Weinhold	fi
155022fa244SIngo Weinhold}
156022fa244SIngo Weinhold
15720ab75e6SIngo Weinhold# assertparams
15820ab75e6SIngo Weinhold#
15920ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16020ab75e6SIngo Weinhold#
16120ab75e6SIngo Weinholdassertparams()
16220ab75e6SIngo Weinhold{
16320ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
16420ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
16520ab75e6SIngo Weinhold		exit 1
16620ab75e6SIngo Weinhold	fi
16720ab75e6SIngo Weinhold}
16820ab75e6SIngo Weinhold
169e173a1ecSIngo Weinhold# absolute_path
170e173a1ecSIngo Weinhold#
171e173a1ecSIngo Weinhold# returns the absolute path of a given path.
172e173a1ecSIngo Weinhold#
173e173a1ecSIngo Weinholdabsolute_path()
174e173a1ecSIngo Weinhold{
1756a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
176e173a1ecSIngo Weinhold		echo "$1"
177e173a1ecSIngo Weinhold	else
178e173a1ecSIngo Weinhold		echo "`pwd`/$1"
179e173a1ecSIngo Weinhold	fi
180e173a1ecSIngo Weinhold}
181e173a1ecSIngo Weinhold
18239d444a3SArvind S Raj# check_dir_exists
18339d444a3SArvind S Raj#
18439d444a3SArvind S Raj# check if a directory exists or not
18539d444a3SArvind S Raj#
18639d444a3SArvind S Rajcheck_dir_exists()
18739d444a3SArvind S Raj{
18839d444a3SArvind S Raj	if [ -d "$1" ]; then
18939d444a3SArvind S Raj		return 0
19039d444a3SArvind S Raj	else
19139d444a3SArvind S Raj		return 1
19239d444a3SArvind S Raj	fi
19339d444a3SArvind S Raj}
19439d444a3SArvind S Raj
195502882dbSJessica Hamilton# check_file_exists
196502882dbSJessica Hamilton#
197502882dbSJessica Hamilton# check if a file exists or not
198502882dbSJessica Hamilton#
199502882dbSJessica Hamiltoncheck_file_exists()
200502882dbSJessica Hamilton{
201502882dbSJessica Hamilton	if [ -f "$1" ]; then
202502882dbSJessica Hamilton		return 0
203502882dbSJessica Hamilton	else
204502882dbSJessica Hamilton		return 1
205502882dbSJessica Hamilton	fi
206502882dbSJessica Hamilton}
207502882dbSJessica Hamilton
2089a001156SOliver Tappe# real_path
2099a001156SOliver Tappe#
2109a001156SOliver Tappe# returns the realpath of a symbolic link.
2119a001156SOliver Tappe#
2129a001156SOliver Tappereal_path()
2139a001156SOliver Tappe{
2149a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2159a001156SOliver Tappe}
2169a001156SOliver Tappe
2173facc270SAugustin Cavalier# relative_to
2183facc270SAugustin Cavalier#
2193facc270SAugustin Cavalier# returns $1 relative to $2
2203facc270SAugustin Cavalier#
2213facc270SAugustin Cavalierrelative_to()
2223facc270SAugustin Cavalier{
2233facc270SAugustin Cavalier	perl -e 'use File::Spec; print File::Spec->abs2rel(@ARGV) . "\n"' \
2241d91b371SAugustin Cavalier		"$1" "$2"
2253facc270SAugustin Cavalier}
2263facc270SAugustin Cavalier
227e5d446fcSAlexander von Gluck IV# valid_toolchain
228e5d446fcSAlexander von Gluck IV#
2291f839e89Swaddlesplash# check if a toolchain is valid
230e5d446fcSAlexander von Gluck IV#
231e5d446fcSAlexander von Gluck IVvalid_toolchain()
232e5d446fcSAlexander von Gluck IV{
233e5d446fcSAlexander von Gluck IV	TRIPLET="$1"
234e5d446fcSAlexander von Gluck IV	BASE="$2"
2351f839e89Swaddlesplash	SOURCE="$3"
236e5d446fcSAlexander von Gluck IV	if [ ! -d "$BASE" ]; then
2371f839e89Swaddlesplash		return 1
238e5d446fcSAlexander von Gluck IV	fi
239e5d446fcSAlexander von Gluck IV	if [ -f "$BASE/bin/$TRIPLET-gcc" ]; then
2401f839e89Swaddlesplash		[ "$BASE/bin/$TRIPLET-gcc" -nt "$SOURCE/legacy/gcc/configure" ] && \
2411f839e89Swaddlesplash			[ "$BASE/bin/$TRIPLET-gcc" -nt "$SOURCE/gcc/gcc/configure" ]
2421f839e89Swaddlesplash		return $?
243e5d446fcSAlexander von Gluck IV	fi
2441f839e89Swaddlesplash	return 1
245e5d446fcSAlexander von Gluck IV}
246e5d446fcSAlexander von Gluck IV
24747320dd0SAugustin Cavalier# is_legacy_gcc
24847320dd0SAugustin Cavalier#
24947320dd0SAugustin Cavalier# Determines if the specified GCC version is a "legacy" (i.e. GCC < 4) one.
25047320dd0SAugustin Cavalier#
25147320dd0SAugustin Cavalieris_legacy_gcc()
25247320dd0SAugustin Cavalier{
25347320dd0SAugustin Cavalier	if [ `echo $1 | cut -d'.' -f1` -lt 4 ]; then
25447320dd0SAugustin Cavalier		echo 1
25547320dd0SAugustin Cavalier	else
25647320dd0SAugustin Cavalier		echo 0
25747320dd0SAugustin Cavalier	fi
25847320dd0SAugustin Cavalier}
25947320dd0SAugustin Cavalier
26009c5682dSIngo Weinhold# standard_gcc_settings
26109c5682dSIngo Weinhold#
26209c5682dSIngo Weinhold# Sets the variables for a GCC platform.
26309c5682dSIngo Weinhold#
26409c5682dSIngo Weinholdstandard_gcc_settings()
26509c5682dSIngo Weinhold{
26665706842SAugustin Cavalier	local gcc="$1"
267c0e8cc1aSIngo Weinhold
268138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
269b29b48b1SMatt Madia		readlink="greadlink -e"
270138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
271b29b48b1SMatt Madia		readlink=realpath
2729a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
273b29b48b1SMatt Madia		readlink="readlink -e"
2749a001156SOliver Tappe	else
2759a001156SOliver Tappe		readlink=real_path
276b4b6d83cSMatt Madia	fi
277138f5fb4SIngo Weinhold
27809c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
279c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
280c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2815b0f7b1bSOliver Tappe
282c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
283c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
284338b8dc3SIngo Weinhold
285fc8967f1SIngo Weinhold	# determine architecture from machine triple
286c0e8cc1aSIngo Weinhold	case $gccMachine in
287c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
2881f52c921SJaroslaw Pelczar		aarch64-*)	targetCpu=arm64;;
289c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
290c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
291c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
2925bd0fbd1SAlexander von Gluck IV		riscv64-*)	targetCpu=riscv64;;
2935629675aSAdrien Destugues		sparc64-*)	targetCpu=sparc;;
294c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
295fc8967f1SIngo Weinhold		*)
296c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
297fc8967f1SIngo Weinhold			exit 1
298fc8967f1SIngo Weinhold			;;
299fc8967f1SIngo Weinhold	esac
300fc8967f1SIngo Weinhold
301c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
302fc8967f1SIngo Weinhold
303c0e8cc1aSIngo Weinhold	case $gccRawVersion in
3046cc8eecfSOliver Tappe		2.9*)
3055b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
3065b0f7b1bSOliver Tappe			# if an older one is installed
307c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
3085b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
3095b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
3105b0f7b1bSOliver Tappe				exit 1;
3115b0f7b1bSOliver Tappe			fi
312aaeadfcbSAlex Smith
313c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
3145b0f7b1bSOliver Tappe			;;
3158b5934c9SIngo Weinhold	esac
31665ad1ba3SAlex Smith
317c0e8cc1aSIngo Weinhold	local bootLibgcc
318c0e8cc1aSIngo Weinhold	local bootLibSupCxx
31966a7f29fSJérôme Duval	local bootCxxHeaders
3204df4b48fSJérôme Duval	local boot32Libgcc
3214df4b48fSJérôme Duval	local boot32LibSupCxx
3224df4b48fSJérôme Duval	local boot32CxxHeaders
323c0e8cc1aSIngo Weinhold	case $gccMachine in
3244591ebc9SAlex Smith		x86_64-*)
32566a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
3264df4b48fSJérôme Duval			boot32Libgcc=`$gcc -m32 -print-file-name=libgcc.a`
3274df4b48fSJérôme Duval			boot32LibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
3284df4b48fSJérôme Duval			bootLibgcc=`$gcc -print-file-name=libgcc.a`
3294df4b48fSJérôme Duval			bootLibSupCxx=`$gcc -print-file-name=libsupc++.a`
33066a7f29fSJérôme Duval
33166a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
33266a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
33366a7f29fSJérôme Duval			if [ ! -d $headers ]; then
33466a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
33566a7f29fSJérôme Duval			fi
3364df4b48fSJérôme Duval			boot32CxxHeaders="$headers/$gccMachine/32"
3374df4b48fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine"
3384591ebc9SAlex Smith			;;
339338b8dc3SIngo Weinhold	esac
340c0e8cc1aSIngo Weinhold
341c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
342c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
343c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
344c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
345c0e8cc1aSIngo Weinhold	fi
346c0e8cc1aSIngo Weinhold
347c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
348c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
349c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
350c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
351c0e8cc1aSIngo Weinhold			useGraphite=0
352c0e8cc1aSIngo Weinhold		fi
353c0e8cc1aSIngo Weinhold	fi
354c0e8cc1aSIngo Weinhold
355c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
356c0e8cc1aSIngo Weinhold
357c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
35847320dd0SAugustin Cavalier	set_variable HAIKU_CC_IS_LEGACY_GCC_$targetArch \
35947320dd0SAugustin Cavalier		`is_legacy_gcc $gccRawVersion`
360a7bddff1SJonathan Schleifer	set_variable HAIKU_CC_IS_CLANG_$targetArch $useClang
361c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
362c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
36366a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
36411ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
36511ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
3664df4b48fSJérôme Duval	set_variable HAIKU_BOOT_32_CXX_HEADERS_DIR_$targetArch "$boot32CxxHeaders"
3674df4b48fSJérôme Duval	set_variable HAIKU_BOOT_32_LIBSUPCXX_$targetArch "$boot32LibSupCxx"
3684df4b48fSJérôme Duval	set_variable HAIKU_BOOT_32_LIBGCC_$targetArch $boot32Libgcc
369c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
370c0e8cc1aSIngo Weinhold
371c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
372c0e8cc1aSIngo Weinhold}
373c0e8cc1aSIngo Weinhold
374c0e8cc1aSIngo Weinhold# set_variable
375c0e8cc1aSIngo Weinhold#
376c0e8cc1aSIngo Weinhold# Set the value of a variable.
377c0e8cc1aSIngo Weinhold#
378c0e8cc1aSIngo Weinholdset_variable()
379c0e8cc1aSIngo Weinhold{
380c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
381c0e8cc1aSIngo Weinhold}
382c0e8cc1aSIngo Weinhold
383c0e8cc1aSIngo Weinhold# get_variable
384c0e8cc1aSIngo Weinhold#
385c0e8cc1aSIngo Weinhold# Echo the value of a variable.
386c0e8cc1aSIngo Weinhold#
387c0e8cc1aSIngo Weinholdget_variable()
388c0e8cc1aSIngo Weinhold{
389c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
39009c5682dSIngo Weinhold}
39109c5682dSIngo Weinhold
392338b8dc3SIngo Weinhold# set_default_value
393338b8dc3SIngo Weinhold#
394338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
395338b8dc3SIngo Weinhold#
396338b8dc3SIngo Weinholdset_default_value()
397338b8dc3SIngo Weinhold{
3980838a930SJérôme Duval	eval "$1=\${$1-$2}"
399338b8dc3SIngo Weinhold}
400338b8dc3SIngo Weinhold
401338b8dc3SIngo Weinhold# get_build_tool_path
402338b8dc3SIngo Weinhold#
403338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
404338b8dc3SIngo Weinhold#
405338b8dc3SIngo Weinholdget_build_tool_path()
406338b8dc3SIngo Weinhold{
407338b8dc3SIngo Weinhold	local var="HAIKU_$1"
40865706842SAugustin Cavalier	local varval="`get_variable $var`"
40965706842SAugustin Cavalier	local cmd="$2"
410d73993ffSAugustin Cavalier
411e042a53bSAugustin Cavalier	if [ ! -z "$varval" ]; then
412d73993ffSAugustin Cavalier		# this variable is already set (probably by user) so grab its contents
413e042a53bSAugustin Cavalier		cmd=$varval
414d73993ffSAugustin Cavalier	fi
415d73993ffSAugustin Cavalier
416d73993ffSAugustin Cavalier	local path=${cmd%% *}
417338b8dc3SIngo Weinhold
418338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
41965706842SAugustin Cavalier		# get absolute path from relative path
420a559f87aSFrançois Revol		local oldPwd="`pwd`"
421a559f87aSFrançois Revol		cd "`dirname "$path"`"
422a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
423338b8dc3SIngo Weinhold		cd $oldPwd
424338b8dc3SIngo Weinhold	else
4257fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
426d73993ffSAugustin Cavalier			echo "Build tool \"$path\" not found (maybe specify it in $var?)" >&2
427338b8dc3SIngo Weinhold			exit 1
428338b8dc3SIngo Weinhold		}
429338b8dc3SIngo Weinhold	fi
430338b8dc3SIngo Weinhold
43165706842SAugustin Cavalier	if test "${cmd#* }" != "$cmd"; then
43265706842SAugustin Cavalier		# $cmd contains arguments, so preserve them (and only them)
43365706842SAugustin Cavalier		cmd=${cmd#* }
43465706842SAugustin Cavalier	else
43565706842SAugustin Cavalier		# $cmd does not contain arguments, so unset it
43665706842SAugustin Cavalier		cmd=
43765706842SAugustin Cavalier	fi
43865706842SAugustin Cavalier	eval "$var=\"$path $cmd\""
439338b8dc3SIngo Weinhold}
440338b8dc3SIngo Weinhold
441a5c952dbSAugustin Cavalier# check_native_xattrs
442a5c952dbSAugustin Cavalier#
443a5c952dbSAugustin Cavalier# Checks the host platform's support for extended attributes.
444a5c952dbSAugustin Cavalier# 0: no support, 1: only enough for xattr-ref, 2: full support
445a5c952dbSAugustin Cavalier#
446a5c952dbSAugustin Cavaliercheck_native_xattrs()
447a5c952dbSAugustin Cavalier{
448a5c952dbSAugustin Cavalier	local xattr_set=
449a5c952dbSAugustin Cavalier	local xattr_set_args=
450a5c952dbSAugustin Cavalier	local xattr_get=
451a5c952dbSAugustin Cavalier	local xattr_get_args=
452a5c952dbSAugustin Cavalier	case $HOST_PLATFORM in
453503ef6d4SAugustin Cavalier		haiku_host)
454503ef6d4SAugustin Cavalier			xattr_set="addattr"; xattr_set_args="\$NAME \"\$VALUE\""
455503ef6d4SAugustin Cavalier			xattr_get="catattr"; xattr_get_args="\$NAME"
456503ef6d4SAugustin Cavalier			;;
457a5c952dbSAugustin Cavalier		darwin)
458a5c952dbSAugustin Cavalier			xattr_set="xattr"; xattr_set_args="-w \$NAME \"\$VALUE\""
459a5c952dbSAugustin Cavalier			xattr_get="xattr"; xattr_get_args="-p \$NAME"
460a5c952dbSAugustin Cavalier			;;
461a5c952dbSAugustin Cavalier		freebsd)
462a5c952dbSAugustin Cavalier			xattr_set="setextattr"; xattr_set_args="user \$NAME \"\$VALUE\""
463a5c952dbSAugustin Cavalier			xattr_get="getextattr"; xattr_get_args="user \$NAME"
464a5c952dbSAugustin Cavalier			;;
465f6381021SAugustin Cavalier		linux)
466a5c952dbSAugustin Cavalier			xattr_set="setfattr"; xattr_set_args="-n user.\$NAME -v \"\$VALUE\""
467a5c952dbSAugustin Cavalier			xattr_get="getfattr"; xattr_get_args="-n user.\$NAME"
468a5c952dbSAugustin Cavalier			;;
469a5c952dbSAugustin Cavalier		*)
470a5c952dbSAugustin Cavalier			return 0
471a5c952dbSAugustin Cavalier			;;
472a5c952dbSAugustin Cavalier	esac
473a5c952dbSAugustin Cavalier	if ! type $xattr_set >/dev/null 2>&1; then
474a5c952dbSAugustin Cavalier		echo "$0: could not find $xattr_set, assuming host has no extended attributes"
475a5c952dbSAugustin Cavalier		return 0
476a5c952dbSAugustin Cavalier	elif ! type $xattr_get >/dev/null 2>&1; then
477a5c952dbSAugustin Cavalier		echo "$0: could not find $xattr_get, assuming host has no extended attributes"
478a5c952dbSAugustin Cavalier		return 0
479a5c952dbSAugustin Cavalier	fi
480a5c952dbSAugustin Cavalier
48143f5f35aSAugustin Cavalier	mkdir -p "$outputDir"
482a5c952dbSAugustin Cavalier	echo "xattr test file" >"$outputDir/xattrtest"
483a5c952dbSAugustin Cavalier	local i=0
484a5c952dbSAugustin Cavalier	# on round 0, we test if we can set 3 attrs of 1K each (enough for xattr-ref)
485a5c952dbSAugustin Cavalier	# on round 1, we test if we can set 3 attrs of 45K each (enough for full xattr)
486a5c952dbSAugustin Cavalier	while [ $i -lt 2 ]; do
487a5c952dbSAugustin Cavalier		local j=0
488a5c952dbSAugustin Cavalier		while [ $j -lt 3 ]; do
489a5c952dbSAugustin Cavalier			NAME=attr$j
490a5c952dbSAugustin Cavalier			VALUE=`printf '%*s' $((1024 + $i * 45056)) "" | tr ' ' x`
491a5c952dbSAugustin Cavalier			if [ `echo -n $VALUE | wc -c` -lt $((1024 + $i * 45056)) ]; then
492a5c952dbSAugustin Cavalier				echo "$0: warning: could not generate test data for extended attributes"
493a5c952dbSAugustin Cavalier				rm "$outputDir/xattrtest"
494a5c952dbSAugustin Cavalier				return $i
495a5c952dbSAugustin Cavalier			elif ! $xattr_set `eval echo \"$xattr_set_args\"` \
496a5c952dbSAugustin Cavalier					"$outputDir/xattrtest" >/dev/null 2>&1 ; then
497a5c952dbSAugustin Cavalier				rm "$outputDir/xattrtest"
498a5c952dbSAugustin Cavalier				return $i
499a5c952dbSAugustin Cavalier			fi
500a5c952dbSAugustin Cavalier			j=$((j+1))
501a5c952dbSAugustin Cavalier		done
502a5c952dbSAugustin Cavalier		i=$((i+1))
503a5c952dbSAugustin Cavalier	done
504a5c952dbSAugustin Cavalier	rm "$outputDir/xattrtest"
505a5c952dbSAugustin Cavalier	return 2
506a5c952dbSAugustin Cavalier}
507a5c952dbSAugustin Cavalier
508483b28e4SIngo Weinholdis_in_list()
509483b28e4SIngo Weinhold{
510483b28e4SIngo Weinhold	local element
511483b28e4SIngo Weinhold	for element in $2; do
512483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
513483b28e4SIngo Weinhold			return 0
514483b28e4SIngo Weinhold		fi
515483b28e4SIngo Weinhold	done
516483b28e4SIngo Weinhold	return 1
517483b28e4SIngo Weinhold}
518483b28e4SIngo Weinhold
5197f9beaf1SOliver Tappe# check for --help or -h and show usage immediately
5207f9beaf1SOliver Tappeif [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
5218b420c2fSOliver Tappe	usage; exit 0;
5228b420c2fSOliver Tappefi
5238b420c2fSOliver Tappe
524338b8dc3SIngo Weinhold# get cwd and the source directory
525338b8dc3SIngo WeinholdcurrentDir=`pwd`
5266e7c6fe5SIngo Weinholdcd `dirname "$0"`
527338b8dc3SIngo WeinholdsourceDir=`pwd`
5286e7c6fe5SIngo Weinholdcd "$currentDir"
529338b8dc3SIngo Weinhold
530a107d3b4SAugustin Cavalier# determine output directory
531a107d3b4SAugustin Cavalierif [ "$currentDir" = "$sourceDir" ]; then
532a107d3b4SAugustin Cavalier	outputDir=$currentDir/generated
533a107d3b4SAugustin Cavalierelse
534a107d3b4SAugustin Cavalier	outputDir=$currentDir
535a107d3b4SAugustin Cavalierfi
536a107d3b4SAugustin CavalierbuildOutputDir="$outputDir/build"
537a107d3b4SAugustin CavalierHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
538a107d3b4SAugustin CavalierbuildConfigFile="$buildOutputDir/BuildConfig"
539a107d3b4SAugustin Cavalier
540a107d3b4SAugustin Cavalier# check for update request
541a107d3b4SAugustin Cavalierif [ "$1" = "--update" ]; then
542a107d3b4SAugustin Cavalier	if ! [ -e "$buildConfigFile" ]; then
543a107d3b4SAugustin Cavalier		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
544a107d3b4SAugustin Cavalier		exit 1
545a107d3b4SAugustin Cavalier	fi
546a107d3b4SAugustin Cavalier	# get last configure invocation and flags from BuildConfig and call ourselves with it
547a107d3b4SAugustin Cavalier	lastPwd=`grep "#d " "$buildConfigFile" | cut -c 4-`
548a107d3b4SAugustin Cavalier	lastConfig=`grep "#c " "$buildConfigFile" | cut -c 4-`
549a107d3b4SAugustin Cavalier	lastEnv=`grep "#e " "$buildConfigFile" | cut -c 4-`
550a107d3b4SAugustin Cavalier	lastArgs=`grep "#a " "$buildConfigFile" | cut -c 4-`
551a107d3b4SAugustin Cavalier	if [ -z "$lastConfig" ]; then
552a107d3b4SAugustin Cavalier		echo "$0 --update: The previous configure invocation was not properly" \
553a107d3b4SAugustin Cavalier			"encoded into '$buildConfigFile' - updating not possible."
554a107d3b4SAugustin Cavalier		exit 1
555a107d3b4SAugustin Cavalier	fi
5561d91b371SAugustin Cavalier	cd "$lastPwd"
557a107d3b4SAugustin Cavalier	if [ -n "$lastEnv" ]; then
558a107d3b4SAugustin Cavalier		export $lastEnv
559a107d3b4SAugustin Cavalier	fi
560a107d3b4SAugustin Cavalier	$lastConfig $lastArgs
561a107d3b4SAugustin Cavalier	exit $?
562a107d3b4SAugustin Cavalierfi
563a107d3b4SAugustin Cavalier
56455d267a4SFrançois Revol# backup the passed arguments
56555d267a4SFrançois RevolconfigureArgs="$@"
566825700d3SAugustin CavalierconfigurePath=$0
5676f582441SKacper KasperconfigureDir=`dirname $configurePath`
568825700d3SAugustin Cavalier
569825700d3SAugustin Cavalier# backup relevant environs
570825700d3SAugustin CavalierconfigureEnvirons=
571825700d3SAugustin Cavalierfor var in `env`; do
572825700d3SAugustin Cavalier	case "$var" in
5737d72ed01SAugustin Cavalier		CC\=*|HAIKU*\=*|JAMSHELL\=*)
574825700d3SAugustin Cavalier			configureEnvirons="$configureEnvirons $var"
575825700d3SAugustin Cavalier			;;
576825700d3SAugustin Cavalier	esac
577825700d3SAugustin Cavalierdone
57855d267a4SFrançois Revol
579a107d3b4SAugustin Cavalier# ensure umask is not too restrictive
58002f3646aSAugustin Cavalierif [ `umask` -gt 22 ]; then
58102f3646aSAugustin Cavalier	echo Your umask is too restrictive "(should be <= 0022;" is actually `umask`")"
58202f3646aSAugustin Cavalier	echo
58302f3646aSAugustin Cavalier	echo Additionally, if the source tree was cloned with a too-restrictive umask,
58402f3646aSAugustin Cavalier	echo you will need to run \"git checkout\" again to fix this.
585a107d3b4SAugustin Cavalier	exit 1
586a107d3b4SAugustin Cavalierfi
587a107d3b4SAugustin Cavalier
5887c4641d0SOliver Tappe# internal default parameter values
589022fa244SIngo Weinhold#
59052a38012Sejakowatzplatform=`uname`
5915abd9a46SIngo WeinholdplatformMachine=`uname  -m`
592c0e8cc1aSIngo WeinholdtargetArchs=
593338b8dc3SIngo WeinholdbuildCrossTools=
59429ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
59560d8d8fcSIngo WeinholdbuildCrossToolsJobs=
596c2b76f7fSJonathan SchleiferuseClang=0
597c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
598c0e8cc1aSIngo WeinholdunknownArchIndex=1
599483b28e4SIngo WeinholdhaikuTargetArchs=
6004da6cf84SFrançois RevolgdbSources=
6017c4641d0SOliver Tappe
60263701e7dSOliver Tappeif [ -z "$CC" ]; then
60363701e7dSOliver Tappe	CC=gcc
60463701e7dSOliver Tappefi
6050bbef5d7SAugustin Cavalierif [ $(is_legacy_gcc $($CC -dumpversion)) -ne 0 ]; then
6060bbef5d7SAugustin Cavalier	echo The host tools cannot be built with a legacy version of GCC.
6070bbef5d7SAugustin Cavalier	echo Please specify a more modern compiler in the "CC" environ.
6080bbef5d7SAugustin Cavalier	exit 1
6090bbef5d7SAugustin Cavalierfi
61063701e7dSOliver Tappe
6112a1cc90eSJohn Scipione# detect the build platform
6122a1cc90eSJohn Scipionecase "${platform}" in
6132a1cc90eSJohn Scipione	Darwin)  HOST_PLATFORM=darwin ;;
6142a1cc90eSJohn Scipione	FreeBSD) HOST_PLATFORM=freebsd
6152a1cc90eSJohn Scipione	         if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6162a1cc90eSJohn Scipione	         	echo Unsupported platform: FreeBSD ${platformMachine}
6172a1cc90eSJohn Scipione	         	exit 1
6182a1cc90eSJohn Scipione	         fi ;;
6192a1cc90eSJohn Scipione	Haiku)   HOST_PLATFORM=haiku_host ;;
6202a1cc90eSJohn Scipione	Linux)   HOST_PLATFORM=linux ;;
6212a1cc90eSJohn Scipione	OpenBSD) HOST_PLATFORM=openbsd ;;
6222a1cc90eSJohn Scipione	*)       echo Unsupported platform: ${platform}
6232a1cc90eSJohn Scipione	         exit 1 ;;
6242a1cc90eSJohn Scipioneesac
6252a1cc90eSJohn Scipione
6262a1cc90eSJohn Scipionecase $HOST_PLATFORM in
6272a1cc90eSJohn Scipione	darwin|freebsd|openbsd) statCmd='stat -f' ;;
6282a1cc90eSJohn Scipione	*)                      statCmd='stat -c' ;;
6292a1cc90eSJohn Scipioneesac
6302a1cc90eSJohn Scipione
6312a1cc90eSJohn Scipione# ensure git checkout was not done with a restrictive umask
6322a1cc90eSJohn Scipioneif [ `$statCmd '%a' "$sourceDir/data/system/boot/SetupEnvironment"` -lt 644 ]; then
6332a1cc90eSJohn Scipione	echo "The source tree was cloned with a umask > 0022. It seems you"
6342a1cc90eSJohn Scipione	echo have already corrected your umask, but not re-checked-out the
6352a1cc90eSJohn Scipione	echo source tree. Try running:
6362a1cc90eSJohn Scipione	echo "	git checkout --force"
6372a1cc90eSJohn Scipione	echo to fix this problem.
6382a1cc90eSJohn Scipione	exit 1
6392a1cc90eSJohn Scipionefi
6402a1cc90eSJohn Scipione
6417c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
6427c4641d0SOliver Tappe#
6436f582441SKacper KasperGIT_DIR=`git -C "$configureDir" rev-parse --git-dir | sed 's/^gitdir: //'`
64463701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
64576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
6467c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
6477c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
6487c4641d0SOliver TappeTARGET_PLATFORM=haiku
6497c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
6507986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
651fc2c93fbSAugustin CavalierHAIKU_HOST_USE_XATTR=
652fc2c93fbSAugustin CavalierHAIKU_HOST_USE_XATTR_REF=
6532ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
654f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
65563701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
65663701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
6572a5d0aafSIngo WeinholdHOST_SHA256=
658e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
659e173a1ecSIngo WeinholdHAIKU_PORTS=
660e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
661c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP=0
662aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
6632a5d0aafSIngo Weinhold
664c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
665c0e8cc1aSIngo Weinhold
666a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
667c0e8cc1aSIngo Weinhold
6683942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
6692a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
6703942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
6712a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
672b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
673b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
6742a5d0aafSIngo Weinholdelse
6752a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
6762a5d0aafSIngo Weinhold	exit 1
6772a5d0aafSIngo Weinholdfi
678338b8dc3SIngo Weinhold
67984edb1a1SAxel DörflerhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2017_07_20"
680a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
681af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
682483b28e4SIngo WeinholdsupportedTargetArchs="
683483b28e4SIngo Weinhold	arm
684fb4cc984SAugustin Cavalier	arm64
685483b28e4SIngo Weinhold	m68k
686483b28e4SIngo Weinhold	ppc
6875bd0fbd1SAlexander von Gluck IV	riscv64
688f23db0edSPulkoMandy	sparc
689483b28e4SIngo Weinhold	x86
690483b28e4SIngo Weinhold	x86_64
691483b28e4SIngo Weinhold	x86_gcc2
692483b28e4SIngo Weinhold	"
693af4bf973SOliver Tappe
694022fa244SIngo Weinhold# parse parameters
695022fa244SIngo Weinhold#
69620ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
697022fa244SIngo Weinhold	case "$1" in
698e9e00b80SJessica Hamilton		--sysroot)
699e9e00b80SJessica Hamilton			assertparam "$1" $#
700e9e00b80SJessica Hamilton			crossToolsSysroot=$2
701e9e00b80SJessica Hamilton			shift 2
702e9e00b80SJessica Hamilton			;;
703e173a1ecSIngo Weinhold		--bootstrap)
704e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
705e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
706e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
707e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
708c9dd05ffSJonathan Schleifer			HAIKU_IS_BOOTSTRAP=1
709c9dd05ffSJonathan Schleifer			HAIKU_NO_DOWNLOADS=1
710502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
711502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
71239d444a3SArvind S Raj				exit 1
71339d444a3SArvind S Raj			)
71439d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
71539d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
71639d444a3SArvind S Raj				exit 1
71739d444a3SArvind S Raj			)
71839d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
71939d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
72039d444a3SArvind S Raj				exit 1
72139d444a3SArvind S Raj			)
722e173a1ecSIngo Weinhold			shift 4
723e173a1ecSIngo Weinhold			;;
72414d8c772SAlexander von Gluck IV		--cross-tools-source)
72514d8c772SAlexander von Gluck IV			assertparam "$1" $#
72614d8c772SAlexander von Gluck IV			buildCrossTools=$2
72714d8c772SAlexander von Gluck IV			shift 2
72814d8c772SAlexander von Gluck IV			;;
729c0e8cc1aSIngo Weinhold		--build-cross-tools)
730c0e8cc1aSIngo Weinhold			assertparam "$1" $#
731c0e8cc1aSIngo Weinhold			targetArch=$2
732c0e8cc1aSIngo Weinhold			shift 2
733c0e8cc1aSIngo Weinhold			case "$targetArch" in
734c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
735c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
736c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
737c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
738c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
739c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
7401f52c921SJaroslaw Pelczar				arm64)		targetMachine=aarch64-unknown-haiku;;
7415bd0fbd1SAlexander von Gluck IV				riscv64)	targetMachine=riscv64-unknown-haiku;;
7425629675aSAdrien Destugues				sparc)		targetMachine=sparc64-unknown-haiku;;
743c0e8cc1aSIngo Weinhold				*)
744101564e4SAugustin Cavalier					echo "Unsupported target architecture: $targetArch" >&2
745c0e8cc1aSIngo Weinhold					exit 1
746c0e8cc1aSIngo Weinhold					;;
747c0e8cc1aSIngo Weinhold			esac
748c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
749c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
7509b0dd528SIngo Weinhold			;;
7519b0dd528SIngo Weinhold		--cross-tools-prefix)
7529b0dd528SIngo Weinhold			assertparam "$1" $#
753c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
754c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
755c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
756d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
7579b0dd528SIngo Weinhold			shift 2
7589b0dd528SIngo Weinhold			;;
759a66c32ddSIngo Weinhold		--distro-compatibility)
7609b0dd528SIngo Weinhold			assertparam "$1" $#
7617c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
7627c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
763a66c32ddSIngo Weinhold				official)	;;
764a66c32ddSIngo Weinhold				compatible)	;;
765a66c32ddSIngo Weinhold				default)	;;
766a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
7677c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
768a66c32ddSIngo Weinhold							exit 1;;
769a66c32ddSIngo Weinhold			esac
7709b0dd528SIngo Weinhold			shift 2
7719b0dd528SIngo Weinhold			;;
7722ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
77376fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
7747c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
77560d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
776aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
777483b28e4SIngo Weinhold		--target-arch)
778483b28e4SIngo Weinhold			assertparam "$1" $#
779483b28e4SIngo Weinhold			targetArch=$2
780483b28e4SIngo Weinhold			shift 2
781483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
782483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
783483b28e4SIngo Weinhold				exit 1
784483b28e4SIngo Weinhold			fi
785483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
786483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
787483b28e4SIngo Weinhold				exit 1
788483b28e4SIngo Weinhold			)
789483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
790483b28e4SIngo Weinhold			;;
791d73993ffSAugustin Cavalier		--use-clang)
792d73993ffSAugustin Cavalier			assertparam "$1" $#
793d73993ffSAugustin Cavalier			targetArch=$2
794d73993ffSAugustin Cavalier			useClang=1
795d73993ffSAugustin Cavalier			case "$targetArch" in
796d73993ffSAugustin Cavalier				x86)		targetMachine=i586-pc-haiku;;
797d73993ffSAugustin Cavalier				x86_64)		targetMachine=x86_64-unknown-haiku;;
798d9f698eaSAugustin Cavalier				ppc)		targetMachine=powerpc-apple-haiku;;
79920dbf032SAlexander von Gluck IV				arm)		targetMachine=arm-unknown-haiku;;
8001f52c921SJaroslaw Pelczar				arm64)		targetMachine=aarch64-unknown-haiku;;
8015bd0fbd1SAlexander von Gluck IV				riscv64)	targetMachine=riscv64-unknown-haiku;;
8025629675aSAdrien Destugues				sparc)		targetMachine=sparc64-unknown-haiku;;
803d73993ffSAugustin Cavalier				*)
804d73993ffSAugustin Cavalier					echo "Unsupported target architecture: $2" >&2
805d73993ffSAugustin Cavalier					exit 1
806d73993ffSAugustin Cavalier					;;
807d73993ffSAugustin Cavalier			esac
80865706842SAugustin Cavalier			get_build_tool_path clang clang
80936f28382SAugustin Cavalier			if [ -z `get_variable "crossToolsPrefix_$targetArch"` ] \
81036f28382SAugustin Cavalier					&& [ -z `get_variable buildCrossToolsMachine_$targetArch` ]; then
81165706842SAugustin Cavalier				set_variable crossToolsPrefix_$targetArch llvm-
81265706842SAugustin Cavalier			fi
8135924b6e4SAugustin Cavalier			clangVersion=`$HAIKU_clang -v 2>&1 | head -1 | cut -d " " -f3`
814583db6f5SAlexander von Gluck IV			if [ `echo $clangVersion | cut -d'.' -f1` -lt 7 ]; then
8155924b6e4SAugustin Cavalier				echo "Haiku requires Clang 7 or better to build, but you have $clangVersion."
8165924b6e4SAugustin Cavalier				echo "Please install a newer version."
8175924b6e4SAugustin Cavalier				exit 1
8185924b6e4SAugustin Cavalier			fi
819d73993ffSAugustin Cavalier			targetArchs="$targetArchs $targetArch"
820d73993ffSAugustin Cavalier			shift 2
821d73993ffSAugustin Cavalier			;;
8227c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
823c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
8247986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
825fc2c93fbSAugustin Cavalier		--no-full-xattr)HAIKU_HOST_USE_XATTR=0; shift 1;;
826fc2c93fbSAugustin Cavalier		--no-xattr)		HAIKU_HOST_USE_XATTR_REF=0; shift 1;;
8274da6cf84SFrançois Revol		--with-gdb)	gdbSources=$2; shift 2;;
82804be20a7SJérôme Duval		--use-stack-protector)	HAIKU_USE_STACK_PROTECTOR=1; shift 1;;
82931f27c4dSAlexander von Gluck IV		--efi-signing-key)
83031f27c4dSAlexander von Gluck IV			assertparam "$1" $#
83131f27c4dSAlexander von Gluck IV			HAIKU_EFI_SIGNING_KEY="$2"
83231f27c4dSAlexander von Gluck IV			shift 2
83331f27c4dSAlexander von Gluck IV			;;
834022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
835022fa244SIngo Weinhold	esac
836022fa244SIngo Weinholddone
837022fa244SIngo Weinhold
8380962132cSAlex Smith# check for case-sensitive filesystem
8390962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
8400962132cSAlex Smithmkdir haikucasetest 2>/dev/null
8410962132cSAlex SmithcaseInsensitive=$?
84297f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
8430962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
8443ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
8450962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
8467a05e252SJohn Scipione		echo "You can create a case-sensitive disk image using Disk Utility."
8473ecc5287SMichael Lotz	fi
8480962132cSAlex Smith	exit 1
8493ecc5287SMichael Lotzfi
8503ecc5287SMichael Lotz
851a5c952dbSAugustin Cavalier# check xattr support
852503ef6d4SAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR_REF ]; then
853a5c952dbSAugustin Cavalier	check_native_xattrs
854a5c952dbSAugustin Cavalier	attrSupport=$?
855fc2c93fbSAugustin Cavalier	if [ $attrSupport = 2 ] && [ -z $HAIKU_HOST_USE_XATTR ]; then
856fc2c93fbSAugustin Cavalier		HAIKU_HOST_USE_XATTR=1
857a5c952dbSAugustin Cavalier	elif [ $attrSupport = 1 ]; then
858fc2c93fbSAugustin Cavalier		HAIKU_HOST_USE_XATTR_REF=1
859a5c952dbSAugustin Cavalier	fi
860a5c952dbSAugustin Cavalierfi
861fc2c93fbSAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR ]; then HAIKU_HOST_USE_XATTR=0; fi
862fc2c93fbSAugustin Cavalierif [ -z $HAIKU_HOST_USE_XATTR_REF ]; then HAIKU_HOST_USE_XATTR_REF=0; fi
863a5c952dbSAugustin Cavalier
864f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
865f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
866f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
867f04f7042SNiels Sascha Reedijkfi
868f04f7042SNiels Sascha Reedijk
8697d72ed01SAugustin Cavalier# pick a JAMSHELL
8707d72ed01SAugustin Cavalierif [ "$JAMSHELL" = "" ]; then
8717d72ed01SAugustin Cavalier	if check_file_exists /bin/dash; then
8727d72ed01SAugustin Cavalier		JAMSHELL=/bin/dash
8737d72ed01SAugustin Cavalier	else
8747d72ed01SAugustin Cavalier		JAMSHELL=/bin/sh
8757d72ed01SAugustin Cavalier	fi
8767d72ed01SAugustin Cavalierfi
8777d72ed01SAugustin Cavalierif ! $JAMSHELL -c true; then
8787d72ed01SAugustin Cavalier	echo "$JAMSHELL does not work! Please specify a working JAMSHELL."
8797d72ed01SAugustin Cavalier	exit 1
8807d72ed01SAugustin Cavalierfi
8817d72ed01SAugustin Cavalier
8822b200496SAugustin Cavalier# locate python
8832b200496SAugustin Cavalierif python3 --version < /dev/null > /dev/null 2>&1; then
88417dc34acSAndrew Lindesay	HOST_PYTHON="python3"
8852b200496SAugustin Cavalierelif python --version < /dev/null > /dev/null 2>&1; then
88617dc34acSAndrew Lindesay	HOST_PYTHON="python"
88717dc34acSAndrew Lindesayelse
88817dc34acSAndrew Lindesay	echo "a python interpreter is required"
88917dc34acSAndrew Lindesay	exit 1
89017dc34acSAndrew Lindesayfi
89117dc34acSAndrew Lindesay
892cb721c59SFrançois Revol# check if nasm can actually output ELF files
893cb721c59SFrançois Revol# (the stock version in OSX can't)
894cb721c59SFrançois Revol# XXX: should probably only test for x86* arch
8953e6c09cdSAdrien Destuguesif [ "$("$HAIKU_NASM" -hf | grep -c elf'[36][24] ')" -ne "2" ]; then
896cb721c59SFrançois Revol	echo "$HAIKU_NASM cannot generate ELF files. Please install a working version."
897cb721c59SFrançois Revol	if [ $HOST_PLATFORM = "darwin" ]; then
898cb721c59SFrançois Revol		echo "You can install it from Mac Ports."
899cb721c59SFrançois Revol		echo "Mac Ports is available at: http://www.macports.org/"
900cb721c59SFrançois Revol	fi
901cb721c59SFrançois Revol	exit 1
902cb721c59SFrançois Revolfi
903cb721c59SFrançois Revol
904338b8dc3SIngo Weinhold# create output directory
9056e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
906338b8dc3SIngo Weinhold
9072ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
9082ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
9092ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
9102ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
9112ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
9122ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
9132ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
9142ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
915d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
9162ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
9172ebcd86dSIngo Weinholdelse
918483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
919c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
920483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
921483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
922eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
923483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
9247f9beaf1SOliver Tappe			echo "For more info, invoke $0 --help"
925483b28e4SIngo Weinhold			exit 1
926483b28e4SIngo Weinhold		fi
927483b28e4SIngo Weinhold
928483b28e4SIngo Weinhold		# determine primary architecture
929dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
930483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
931483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
932483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
933483b28e4SIngo Weinhold			exit 1
934483b28e4SIngo Weinhold		)
935c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
936483b28e4SIngo Weinhold
937c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
938c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
939c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
940c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
941c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
942c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
943c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
944483b28e4SIngo Weinhold
945483b28e4SIngo Weinhold		# determine secondary architectures
946483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
94780262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
948483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
949483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
950483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
951483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
952483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
953483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
954483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
955483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
956483b28e4SIngo Weinhold			fi
957483b28e4SIngo Weinhold		done
958483b28e4SIngo Weinhold
959483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
960483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
961483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
962483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
963483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
964483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
965483b28e4SIngo Weinhold						"be specified." >&2
966483b28e4SIngo Weinhold					exit 1
967483b28e4SIngo Weinhold				)
968483b28e4SIngo Weinhold			done
969483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
970483b28e4SIngo Weinhold		fi
971c0e8cc1aSIngo Weinhold	fi
972c0e8cc1aSIngo Weinhold
97378b22458SAugustin Cavalier	if [ "$targetArchs" = " x86_gcc2" ]; then
97478b22458SAugustin Cavalier		echo "Building a GCC2-only Haiku is no longer supported."
97578b22458SAugustin Cavalier		echo "Please configure the secondary architecture."
97678b22458SAugustin Cavalier		exit 1
97778b22458SAugustin Cavalier	fi
97878b22458SAugustin Cavalier
97968ccc989SIngo Weinhold	isPrimaryArch=1
980c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
9816c5fcb4fSAugustin Cavalier		# Note: targetArch is "unknown<n>" at this point if a cross-tools
982c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
983c0e8cc1aSIngo Weinhold		# the actual architecture.
984c0e8cc1aSIngo Weinhold
985c7b5f282SAugustin Cavalier		for existingArch in $HAIKU_PACKAGING_ARCHS; do
986c7b5f282SAugustin Cavalier			if [ $existingArch = $targetArch ]; then
9876c5fcb4fSAugustin Cavalier				# somehow we wound up with a duplicate arch; skip this one
988c7b5f282SAugustin Cavalier				targetArch=
989c7b5f282SAugustin Cavalier				break
990c7b5f282SAugustin Cavalier			fi
991c7b5f282SAugustin Cavalier		done
992c7b5f282SAugustin Cavalier		if [ -z "$targetArch" ]; then
9936c5fcb4fSAugustin Cavalier			continue
9946c5fcb4fSAugustin Cavalier		fi
9956c5fcb4fSAugustin Cavalier
996c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
997c0e8cc1aSIngo Weinhold
998338b8dc3SIngo Weinhold		# build cross tools from sources
999c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
1000c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
1001c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
1002c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
10038304ec7cSIngo Weinhold			scriptArgs=
1004c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
10058304ec7cSIngo Weinhold				script="${script}_gcc4"
10068304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
10071e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
10081e93288eSJérôme Duval					$useGccGraphiteDefault
1009c0e8cc1aSIngo Weinhold			fi
101068ccc989SIngo Weinhold			secondaryArch=
101168ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
101268ccc989SIngo Weinhold				secondaryArch=$targetArch
101368ccc989SIngo Weinhold			fi
101486de8c37SIngo Weinhold
101586de8c37SIngo Weinhold			case $HOST_PLATFORM in
101686de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
101786de8c37SIngo Weinhold				*)					MAKE=make;;
101886de8c37SIngo Weinhold			esac
101986de8c37SIngo Weinhold
10201f839e89Swaddlesplash			if ! valid_toolchain "${targetMachine}" "${crossToolsDir}" "${buildCrossTools}"; then
102186de8c37SIngo Weinhold				MAKE=$MAKE \
102268ccc989SIngo Weinhold				SECONDARY_ARCH=$secondaryArch \
1023c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE=`get_variable \
1024c0e8cc1aSIngo Weinhold					HAIKU_USE_GCC_GRAPHITE_$targetArch` \
1025b3ece905SJérôme Duval				HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
10264da6cf84SFrançois Revol				HAIKU_USE_GDB="$gdbSources" \
1027e9e00b80SJessica Hamilton				HAIKU_USE_SYSROOT="$crossToolsSysroot" \
10288304ec7cSIngo Weinhold				"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
10298304ec7cSIngo Weinhold					"$crossToolsDir" $buildCrossToolsJobs || exit 1
1030825700d3SAugustin Cavalier			else
1031825700d3SAugustin Cavalier				echo "$targetArch crosstools already exist in $crossToolsDir; skipping build"
1032825700d3SAugustin Cavalier			fi
1033c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
1034338b8dc3SIngo Weinhold		fi
1035338b8dc3SIngo Weinhold
1036c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
1037a7bddff1SJonathan Schleifer		if [ $useClang = 1 ]; then
1038c44472c5SAugustin Cavalier			gcc="$HAIKU_clang -target ${targetMachine}"
1039ddf7f643SAugustin Cavalier			if [ ! -z "${crossToolsPrefix}" ]; then
1040ddf7f643SAugustin Cavalier				gcc="$gcc -B ${crossToolsPrefix}"
1041ddf7f643SAugustin Cavalier			fi
10421f6fe055SAugustin Cavalier
10431f6fe055SAugustin Cavalier			# Clang's compiler intrinsics are not compatible with GCC's or even
10441f6fe055SAugustin Cavalier			# across versions of Clang, so we must collect them for use in the build.
10451f6fe055SAugustin Cavalier			mkdir -p "$outputDir/clang_headers" || exit 1
104620c61bb7SAugustin Cavalier			clangHeadersDir=`$gcc -print-resource-dir`/include/
104720c61bb7SAugustin Cavalier			case $targetArch in
104820c61bb7SAugustin Cavalier				x86*) cp $clangHeadersDir/*intrin* $clangHeadersDir/mm3* "$outputDir/clang_headers" || exit 1 ;;
104920c61bb7SAugustin Cavalier				ppc*) cp $clangHeadersDir/*altivec* "$outputDir/clang_headers" || exit 1 ;;
105020c61bb7SAugustin Cavalier				arm*) cp $clangHeadersDir/*arm* "$outputDir/clang_headers" || exit 1 ;;
105120c61bb7SAugustin Cavalier			esac
1052d73993ffSAugustin Cavalier		elif [ -z "${crossToolsPrefix}" ]; then
1053d73993ffSAugustin Cavalier			gcc=`get_variable HAIKU_CC_$targetArch`
1054a7bddff1SJonathan Schleifer		else
1055c0e8cc1aSIngo Weinhold			gcc="${crossToolsPrefix}gcc"
1056a7bddff1SJonathan Schleifer		fi
1057*e22ea41cSJessica Hamilton
1058*e22ea41cSJessica Hamilton		if [ -z "$gcc" ]; then
1059*e22ea41cSJessica Hamilton			echo "Please specify the build tools to use or build (via" \
1060*e22ea41cSJessica Hamilton				"--cross-tools-prefix or --build-cross-tools)." >&2
1061*e22ea41cSJessica Hamilton			echo "For more info, invoke $0 --help"
1062*e22ea41cSJessica Hamilton			exit 1
1063*e22ea41cSJessica Hamilton		fi
1064c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
1065c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
1066338b8dc3SIngo Weinhold
1067c0e8cc1aSIngo Weinhold		# set default values for flags
1068c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
1069c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
1070c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
1071252e4f62SAugustin Cavalier		set_default_value HAIKU_LINKFLAGS_$targetArch	""
1072c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
1073241b61a7SAugustin Cavalier		set_default_value HAIKU_ARFLAGS_$targetArch		cru
1074c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
1075338b8dc3SIngo Weinhold
1076c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
1077c0e8cc1aSIngo Weinhold		# prefix was specified.
10781c307243SAugustin Cavalier		if [ -n "$crossToolsPrefix" ]; then
10791c307243SAugustin Cavalier			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
10801c307243SAugustin Cavalier			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
10811c307243SAugustin Cavalier			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
10821c307243SAugustin Cavalier			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
108377d89de0SAugustin Cavalier
108477d89de0SAugustin Cavalier			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
108577d89de0SAugustin Cavalier			if [ `get_variable HAIKU_CC_IS_LEGACY_GCC_$targetArch` -eq 0 ]; then
108677d89de0SAugustin Cavalier				get_build_tool_path ELFEDIT_$targetArch ${crossToolsPrefix}elfedit
108777d89de0SAugustin Cavalier			fi
10881c307243SAugustin Cavalier		fi
108952a38012Sejakowatz
1090ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
1091c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
1092c0e8cc1aSIngo Weinhold		case "$targetMachine" in
1093eedc3d0bSIngo Weinhold			*-*-haiku)	;;
1094c0e8cc1aSIngo Weinhold			*)
1095c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
1096c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
1097eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
1098c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
1099eedc3d0bSIngo Weinhold				exit 1 ;;
1100eedc3d0bSIngo Weinhold		esac
1101c0e8cc1aSIngo Weinhold
1102c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
110368ccc989SIngo Weinhold		isPrimaryArch=
1104c0e8cc1aSIngo Weinhold	done
11052ebcd86dSIngo Weinholdfi
1106eedc3d0bSIngo Weinhold
110752a38012Sejakowatz# Generate BuildConfig
11087c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
1109825700d3SAugustin Cavalier# -- WARNING --
1110825700d3SAugustin Cavalier# This file was AUTOMATICALLY GENERATED by configure, and will be completely
1111825700d3SAugustin Cavalier# overwritten the next time configure is run.
1112825700d3SAugustin Cavalier#
1113825700d3SAugustin Cavalier#d ${currentDir}
1114825700d3SAugustin Cavalier#c ${configurePath}
1115825700d3SAugustin Cavalier#e ${configureEnvirons}
1116825700d3SAugustin Cavalier#a ${configureArgs}
111752a38012Sejakowatz
11186f582441SKacper KasperGIT_DIR						?= "${GIT_DIR}" ;
11196f582441SKacper Kasper
11207c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
1121b57e7df9SAugustin CavalierTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
1122b57e7df9SAugustin CavalierHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
1123338b8dc3SIngo Weinhold
1124b57e7df9SAugustin CavalierHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
112576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES		?= "${HAIKU_INCLUDE_SOURCES}" ;
11267c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY		?= "${HAIKU_INCLUDE_3RDPARTY}" ;
11277c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY	?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
1128b57e7df9SAugustin Cavalier
11297c4641d0SOliver TappeHAIKU_USE_GCC_PIPE			?= "${HAIKU_USE_GCC_PIPE}" ;
11307986925fSIngo WeinholdHAIKU_HOST_USE_32BIT		?= "${HAIKU_HOST_USE_32BIT}" ;
11317986925fSIngo WeinholdHAIKU_HOST_USE_XATTR		?= "${HAIKU_HOST_USE_XATTR}" ;
1132bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF	?= "${HAIKU_HOST_USE_XATTR_REF}" ;
11332ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY		?= "${HAIKU_HOST_BUILD_ONLY}" ;
1134eccc7665SIngo Weinhold
113534fef46bSAugustin CavalierJAMSHELL					?= ${JAMSHELL} -e -c ;
11367d72ed01SAugustin Cavalier
1137b57e7df9SAugustin CavalierHOST_CC						?= ${CC} ;
11387c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
11397c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
11407c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
1141b57e7df9SAugustin CavalierHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
11422a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
114317dc34acSAndrew LindesayHOST_PYTHON					?= ${HOST_PYTHON} ;
1144b57e7df9SAugustin CavalierHAIKU_NASM					?= ${HAIKU_NASM} ;
1145b57e7df9SAugustin Cavalier
11461d91b371SAugustin CavalierHAIKU_BUILD_ATTRIBUTES_DIR	?= "${HAIKU_BUILD_ATTRIBUTES_DIR}" ;
11478b5934c9SIngo Weinhold
1148e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
1149e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
1150e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
1151c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP			?= ${HAIKU_IS_BOOTSTRAP} ;
1152e173a1ecSIngo Weinhold
115331f27c4dSAlexander von Gluck IVHAIKU_BOOT_EFI_PRIVATE_KEYFILE	?= ${HAIKU_EFI_SIGNING_KEY} ;
1154c4786ea6SlilloEOF
1155c4786ea6Slillo
1156c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
1157c0e8cc1aSIngo Weinhold	variables="
1158c1249957SAugustin Cavalier		HAIKU_CC					HAIKU_CC
115947320dd0SAugustin Cavalier		HAIKU_CC_IS_LEGACY_GCC		HAIKU_CC_IS_LEGACY_GCC
1160c1249957SAugustin Cavalier		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
1161c1249957SAugustin Cavalier		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
1162c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
1163c1249957SAugustin Cavalier		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
1164c1249957SAugustin Cavalier		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
1165c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
1166c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
11674df4b48fSJérôme Duval		HAIKU_BOOT_32_LIBGCC		HAIKU_BOOT_32_LIBGCC
11684df4b48fSJérôme Duval		HAIKU_BOOT_32_LIBSUPC++		HAIKU_BOOT_32_LIBSUPCXX
1169c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
1170c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
1171c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
1172c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
1173c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
1174c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
1175c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
1176c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
1177c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
1178252e4f62SAugustin Cavalier		HAIKU_LINKFLAGS				HAIKU_LINKFLAGS
1179c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
1180c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
1181c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
1182c0e8cc1aSIngo Weinhold		"
1183c0e8cc1aSIngo Weinhold	set -- $variables
1184c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1185c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
1186c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
1187c0e8cc1aSIngo Weinhold		shift 2
1188c0e8cc1aSIngo Weinhold	done
1189b1e5b60cSAxel Dörfler
1190c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
1191c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
1192c0e8cc1aSIngo Weinhold	variables="
119366a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
11944df4b48fSJérôme Duval		HAIKU_BOOT_32_C++_HEADERS_DIR	HAIKU_BOOT_32_CXX_HEADERS_DIR
1195c0e8cc1aSIngo Weinhold		"
1196c0e8cc1aSIngo Weinhold	set -- $variables
1197c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1198c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
1199c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
1200c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
1201c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
1202c0e8cc1aSIngo Weinhold		shift 2
1203c0e8cc1aSIngo Weinhold	done
1204c0e8cc1aSIngo Weinholddone
1205b1e5b60cSAxel Dörfler
1206b1e5b60cSAxel Dörfler
12073facc270SAugustin Cavalier# Generate a Jamfile in the output directory.
1208338b8dc3SIngo Weinhold
1209338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
12103facc270SAugustin Cavalier# -- WARNING --
12113facc270SAugustin Cavalier# This file was AUTOMATICALLY GENERATED by configure, and will be completely
12123facc270SAugustin Cavalier# overwritten the next time configure is run.
1213338b8dc3SIngo Weinhold
12143facc270SAugustin CavalierHAIKU_TOP			= $(relative_to "${sourceDir}" "${outputDir}") ;
12153facc270SAugustin CavalierHAIKU_OUTPUT_DIR	= . ;
1216338b8dc3SIngo Weinhold
1217338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
1218338b8dc3SIngo Weinhold
1219338b8dc3SIngo WeinholdEOF
1220d73993ffSAugustin Cavalier
1221d73993ffSAugustin Cavalierecho "Configured successfully!"
1222